## systemd 234

=== debian/changelog ===
systemd (234-2~bpo9+1) stretch-backports; urgency=medium

  * Rebuild for stretch-backports.
  * Switch debian-branch to stretch-backports
  * Don't rely on the debhelper meson build system support.
    This requires a newer debhelper which is not availabe in stretch (yet).

 -- Michael Biebl <biebl@debian.org>  Tue, 08 Aug 2017 23:44:17 +0200

systemd (234-2) unstable; urgency=medium

  [ Martin Pitt ]
  * udev README.Debian: Fix name of example *.link file

  [ Felipe Sateler ]
  * test-condition: Don't assume that all non-root users are normal users.
    Automated builders may run under a dedicated system user, and this test
    would fail that.

  [ Michael Biebl ]
  * Revert "units: Tell login to preserve environment"
    Environment=LANG= LANGUAGE= LC_CTYPE= ... as used in the getty units is
    not unsetting the variables but instead sets it to an empty var. Passing
    that environment to login messes up the system locale settings and
    breaks programs like gpg-agent.
    (Closes: #868695)

 -- Michael Biebl <biebl@debian.org>  Thu, 20 Jul 2017 15:13:42 +0200

systemd (234-1) unstable; urgency=medium

  [ Michael Biebl ]
  * New upstream version 234
    - tmpfiles: Create /var/log/lastlog if it does not exist.
      (Closes: #866313)
    - network: Bridge vlan without PVID. (Closes: #859941)
  * Rebase patches
  * Switch build system from autotools to meson.
    Update the Build-Depends accordingly.
  * Update fsckd patch for meson
  * udev autopkgtest: no longer install test-udev binary manually.
    This is now done by the upstream build system.
  * Update symbols file for libsystemd0
  * Update lintian override for systemd-tests.
    Upstream now installs manual and unsafe tests in subdirectories of
    /usr/lib/systemd/tests/, so ignore those as well.
  * Bump Standards-Version to 4.0.0
  * Change priority of libnss-* packages from extra to optional.
  * Use UTF-8 locale when building the package.
    Otherwise meson will be pretty unhappy when trying to process files with
    unicode characters. Use C.UTF-8 as this locale is pretty much guaranteed
    to be available everywhere.
  * Mark test-timesync as manual.
    The test tries to setup inotify watches for /run/systemd/netif/links
    which fails in a buildd environment where systemd is not active.
  * Do not link udev against libsystemd-shared.
    We ship udev in a separate binary package, so can't use
    libsystemd-shared, which is part of the systemd binary package.
  * Avoid requiring a "kvm" system group.
    This group is not universally available and as a result generates a
    warning during boot. As kvm is only really useful if the qemu package is
    installed and this package already takes care of setting up the proper
    permissions for /dev/kvm, drop this rule from 50-udev-default.rules.

  [ Martin Pitt ]
  * udev README.Debian: Update transitional rules and mention *.link files.
    - 01-mac-for-usb.link got replaced with 73-usb-net-by-mac.rules
    - /etc/systemd/network/50-virtio-kernel-names.link is an upgrade
      transition for VMs with virtio
    - Describe *.link files as a simpler/less error prone (but also less
      flexible) way of customizing interface names. (Closes: #868002)

 -- Michael Biebl <biebl@debian.org>  Thu, 13 Jul 2017 17:38:28 +0200

systemd (233-10) unstable; urgency=medium

  [ Martin Pitt ]
  * Adjust var-lib-machines.mount target.
    Upstream PR #6095 changed the location to
    {remote-fs,machines}.target.wants, so just install all available ones.

  [ Dimitri John Ledkov ]
  * Fix out-of-bounds write in systemd-resolved.
    CVE-2017-9445 (Closes: #866147, LP: #1695546)

  [ Michael Biebl ]
  * Be truly quiet in systemctl -q is-enabled (Closes: #866579)
  * Improve RLIMIT_NOFILE handling.
    Use /proc/sys/fs/nr_open to find the current limit of open files
    compiled into the kernel instead of using a hard-coded value of 65536
    for RLIMIT_NOFILE. (Closes: #865449)

  [ Nicolas Braud-Santoni ]
  * debian/extra/rules: Use updated U2F ruleset.
    This ruleset comes from Yubico's libu2f-host. (Closes: #824532)

 -- Michael Biebl <biebl@debian.org>  Mon, 03 Jul 2017 18:51:58 +0200

systemd (233-9) unstable; urgency=medium

  * hwdb: Use path_join() to generate the hwdb_bin path.
    This ensures /lib/udev/hwdb.bin gets the correct SELinux context. Having
    double slashes in the path makes selabel_lookup_raw() return the wrong
    context. (Closes: #851933)
  * Drop no longer needed Breaks against usb-modeswitch
  * Drop Breaks for packages shipping rcS init scripts.
    This transition was completed in stretch.

 -- Michael Biebl <biebl@debian.org>  Mon, 19 Jun 2017 15:10:14 +0200

systemd (233-8) experimental; urgency=medium

  * Bump debhelper compatibility level to 10
  * Drop versioned Build-Depends on dpkg-dev.
    It's no longer necessary as even Jessie ships a new enough version.
  * timesyncd: don't use compiled-in list if FallbackNTP has been configured
    explicitly (Closes: #861769)
  * resolved: fix null pointer p->question dereferencing.
    This fixes a bug which allowed a remote DoS (daemon crash) via a crafted
    DNS response with an empty question section.
    Fixes: CVE-2017-9217 (Closes: #863277)

 -- Michael Biebl <biebl@debian.org>  Mon, 29 May 2017 14:12:08 +0200

systemd (233-7) experimental; urgency=medium

  [ Michael Biebl ]
  * basic/journal-importer: Fix unaligned access in get_data_size()
    (Closes: #862062)
  * ima: Ensure policy exists before asking the kernel to load it
    (Closes: #863111)
  * Add Depends: procps to systemd.
    It's required by /usr/lib/systemd/user/systemd-exit.service which calls
    /bin/kill to stop the systemd --user instance. (Closes: #862292)
  * service: Serialize information about currently executing command
    (Closes: #861157)
  * seccomp: Add clone syscall definitions for mips (Closes: #861171)

  [ Dimitri John Ledkov ]
  * ubuntu: disable dnssec on any ubuntu releases (LP: #1690605)


